class BinTree {
  constructor(left, element, right) {
    this.left = left;
    this.element = element;
    this.right = right;
    this.isEmpty = false;
  }
  static empty() {
    var result = new BinTree(null,0,null);
    result.isEmpty = true;
    return result;
  }
    
  add(el){
    if (this.isEmpty){
      this.left = BinTree.empty();
      this.element = el;
      this.right = BinTree.empty();
      this.isEmpty = false;
    } else if (el < this.element){
      this.left.add(el);  
    } else if (el > this.element){
      this.right.add(el);  
    }
  }
  size(){
    if (this.isEmpty){
      return 0;
    } else return 1+this.left.size()+this.right.size();
  }
  contains(el){
    if (this.isEmpty){
      return false;
    } else if (el==this.element){
      return true;
    } else if (el < this.element){
      return this.left.contains(el);  
    } else {
      return this.right.contains(el);  
    }
  }
  toArray(result){
    if (this.isEmpty){
      return;
    }
    this.left.toArray(result);
    result.push(this.element);
    this.right.toArray(result);
  }    
}
module.exports = {BinTree}
